{$O+ F+}

UNIT GLFTypes;

(* (C) 1990, 1995 by Johannes Leckebusch *)
(* Version 1.000 *)
(* Stand 07. 01. 1996 *)

{$I SIMPDEF.INC}

INTERFACE

CONST CIconHoehe = 2;

CONST

   evMessageIcon =                        $0400;

(* bersicht ber Bereiche fr cm-Nummern: (OOP-Handbuch S. 169)
   Bereich        Reserviert               Deaktivierbar
   0..99          Ja                       Ja
   100..255       Nein                     Ja
   256..999       Ja                       Nein
   1000..65535    Nein                     Nein
*)

  cmFormBase =                  120;
  cmNeuerText =                 cmFormBase + 6;
  cmLadeText =                  cmFormBase + 7;
  cmLadeNeuenText =             cmFormBase + 8;
  cmOeffneFormular =            cmFormBase + 9;
  cmSchliesseFormular =         cmFormBase + 10;
{$IFDEF mitMedusa}
  cmNeuerParser =               cmFormBase + 11;
  cmLadeNeuenParser =           cmFormBase + 12;
  cmParserLaden =               cmFormBase + 13;
{$ENDIF mitMedusa}
  cmEditClipboard =             cmFormBase + 14;
  cmGetClipboard =              cmFormBase + 15;
  cmSetClipboard =              cmFormBase + 16;

  cmCloseAll =                  cmFormBase + 17;
  {cmCloseNoAsk =                cmFormBase + 18;}

  cmGetHelp =                   cmFormBase + 19;
  cmClearHelp =                 cmFormBase + 20;

  cmFileBase =                  200;
  cmFileOpen =                  cmFileBase + 1; (* NICHT BENUTZT! *)
  cmDosProgramm =               cmFileBase + 3;

  cmWinBase =                   205;
  cmNothing =                   cmWinBase + 1;
  cmNewWin =                    cmWinBase + 2;
  cmMonitor =                   cmWinBase + 3;
  cmOpenDebug =                 cmWinBase + 4;
  cmFlagBox =                   cmWinBase + 5;

  cmBrowserBase =               cmWinBase + 8;
{
  cmMerker =                    cmMerkerBase + 1;
}
  cmWindowBrowse =              cmBrowserBase + 2;
{
  cmChangeMerkerAktiv =         cmMerkerBase + 3;
  cmCopyToMerker =              cmMerkerBase + 4;
  cmCopyFromMerker =            cmMerkerBase + 5;
}
  cmGBEBase =                   1010;
  cmGBE =                       cmGBEBase + 1;
  cmTest =                      cmGBEBase + 2;
  cmTest1 =                     cmGBEBase + 3;
  cmTest2 =                     cmGBEBase + 4;
  cmTest3 =                     cmGBEBase + 5;
  cmGBEMonitor =                cmGBEBase + 6;
  cmSpeicher =                  cmGBEBase + 7;

  cmTRON =                      cmGBEBase + 12;
  cmTROFF =                     cmGBEBase + 13;
  cmError =                     cmGBEBase + 14;
  cmGetTraverser =              cmGBEBase + 15;
  cmSetTraverser =              cmGBEBase + 16;

  cmGetCommandline =            cmGBEBase + 17;

  (* Dateibefehle: *)

  cmDateiBase =                 cmGBEBase + 20;

  cmReport =                    cmDateiBase + 6;
  cmReportName =                cmDateiBase + 7;

  cmTextLaden =                 cmDateiBase + 8;
  cmTexteLaden =                cmDateiBase + 9;
  cmBlockLaden =                cmDateiBase + 10;
  cmEditUndo =                  cmDateiBase + 11;
  cmTextDrucken =               cmDateiBase + 12;
  cmTextNDrucken =              cmDateiBase + 13;
  cmTexteDrucken =              cmDateiBase + 14;
  cmTextLoeschen =              cmDateiBase + 15;
  cmCfgLaden =                  cmDateiBase + 16;
  cmCfgSpeichern =              cmDateiBase + 17;
  cmStringSuchen =              cmDateiBase + 18;
  cmStringRueckSuchen =         cmDateiBase + 19;
  cmZentriereZeile =            cmDateiBase + 20;
  cmStringTauschen =            cmDateiBase + 21;
  cmNochmalSuchen =             cmDateiBase + 22;
  cmNochmalTauschen =           cmDateiBase + 23;
  cmTextLaenge =                cmDateiBase + 24;
  cmBlockLaenge =               cmDateiBase + 25;
  cmCompiliereDruckerfilter =   cmDateiBase + 26;
  cmGeneriereDruckerFilter =    cmDateiBase + 27;
  cmNameAendern =               cmDateiBase + 28;

  cmF1String =                  cmDateiBase + 30;
  cmF2String =                  cmDateiBase + 31;
  cmF3String =                  cmDateiBase + 32;
  cmF4String =                  cmDateiBase + 33;
  cmF5String =                  cmDateiBase + 34;
  cmF6String =                  cmDateiBase + 35;
  cmF7String =                  cmDateiBase + 36;
  cmF8String =                  cmDateiBase + 37;
  cmF9String =                  cmDateiBase + 38;
  cmF0String =                  cmDateiBase + 39;
  cmFStrings =                  cmDateiBase + 40;

  (* Broadcastbefehle fr Window-Refresh und Interkommunikation *)

  cmBroadBase =                 cmDateiBase + 45;
  cmGLFObjektUpdate =           cmBroadBase + 1;
  cmGBEUpdate =                 cmBroadBase + 2;
  cmIconUpdate =                cmBroadBase + 3;
  cmDoUndisplay =               cmBroadBase + 4;
  cmDoDisplay =                 cmBroadBase + 5;
  cmRefreshWindow =             cmBroadBase + 6;
  cmRefresh =                   cmBroadBase + 7;
  cmOffsetUpdate =              cmBroadBase + 8;
  cmSetMerker =                 cmBroadBase + 9;
  cmSetMerkerAktiv =            cmBroadBase + 10;
  cmGetMerker =                 cmBroadBase + 11;
  cmMerkerOffen =               cmBroadBase + 12;
  cmSetWindowTitle =            cmBroadBase + 29;

  cmSelect =                    cmBroadBase + 30;

  cmSetFlag =                   cmBroadBase + 31;

  (* Editbefehle: *)

  cmEditBase =                  cmBroadBase + 40;
  cmEditObjekt =                cmEditBase + 1;
  (****** Neu in SIMPEL *******)
  cmToggleInsert =              cmEditBase + 2;
  cmEditHome =                  cmEditBase + 3;
  cmEditEnd =                   cmEditBase + 4;
  cmEditPgUp =                  cmEditBase + 5;
  cmEditPgDown =                cmEditBase + 6;
  cmEditWortanfang =            cmEditBase + 7;
  cmEditWortende =              cmEditBase + 8;
  cmEditCtrlHome =              cmEditBase + 9;
  cmEditCtrlEnd =               cmEditBase + 10;
  cmEditCtrlPgUp =              cmEditBase + 11;
  cmEditCtrlPgDown =            cmEditBase + 12;
  cmEditUmbruch =               cmEditBase + 13;
  cmEditDokUmbruch =            cmEditBase + 14;
  cmEditLoeschZeile =           cmEditBase + 15;
  cmEditUndoLoeschZeile =       cmEditBase + 16;
  cmEditSteuerzeichen =         cmEditBase + 17;
  cmEditTextmodus =             cmEditBase + 18;
  cmEditProgrammmodus =         cmEditBase + 19;
  cmEditRot13 =                 cmEditBase + 38;
  cmEditKrypt =                 cmEditBase + 39;
  cmWriteText =                 cmEditBase + 40;
  cmWriteZch =                  cmEditBase + 41;
  cmCr =                        cmEditBase + 42;
  cmEditScrollUp =              cmEditBase + 43;
  cmEditScrollDown =            cmEditBase + 44;

  cmMerkerBase =                cmEditBase + 50;

  cmEditSetBlockBegin =         cmMerkerBase + 1;
  cmEditSetBlockEnd =           cmMerkerBase + 2;
  cmEditToBlockBegin =          cmMerkerBase + 3;
  cmEditToBlockEnd =            cmMerkerBase + 4;
  cmEditToAltePos =             cmMerkerBase + 5;
  cmEditCopyBlock =             cmMerkerBase + 6;
  cmEditCutBlock =              cmMerkerBase + 7;
  cmEditPasteBlock =            cmMerkerBase + 8;
  cmEditDoubleBlock =           cmMerkerBase + 9;
  cmEditMoveBlock =             cmMerkerBase + 10;
  cmEditHideBlock =             cmMerkerBase + 11;

  cmEditSet0 =                  cmMerkerBase + 12;
  cmEditSet1 =                  cmMerkerBase + 13;
  cmEditSet2 =                  cmMerkerBase + 14;
  cmEditSet3 =                  cmMerkerBase + 15;
  cmEditSet4 =                  cmMerkerBase + 16;
  cmEditSet5 =                  cmMerkerBase + 17;
  cmEditSet6 =                  cmMerkerBase + 18;
  cmEditSet7 =                  cmMerkerBase + 19;
  cmEditSet8 =                  cmMerkerBase + 20;
  cmEditSet9 =                  cmMerkerBase + 21;

  cmEditTo0 =                  cmMerkerBase + 22;
  cmEditTo1 =                  cmMerkerBase + 23;
  cmEditTo2 =                  cmMerkerBase + 24;
  cmEditTo3 =                  cmMerkerBase + 25;
  cmEditTo4 =                  cmMerkerBase + 26;
  cmEditTo5 =                  cmMerkerBase + 27;
  cmEditTo6 =                  cmMerkerBase + 28;
  cmEditTo7 =                  cmMerkerBase + 29;
  cmEditTo8 =                  cmMerkerBase + 30;
  cmEditTo9 =                  cmMerkerBase + 31;
  cmUpdateMerker =             cmMerkerBase + 32;

  (* Browserbefehle *)

  cmBrowseBase =                cmMerkerBase + 50;

  cmBrowseAktElement =          cmBrowseBase + 8;

  cmFlags =                     cmBrowseBase + 14;
  cmFormFlags =                 cmBrowseBase + 15;
  cmTextflags =                 cmBrowseBase + 16;
  cmParsflags =                 cmBrowseBase + 19;

  cmHeapBase =                  cmBrowseBase + 20;

  cmPROTOKOLL =                 cmHeapBase + 8;

  cmScreenOptionBase =          cmHeapBase + 10;

  cmHighScreen =                cmScreenOptionBase + 1;
  cmLowScreen =                 cmScreenOptionBase + 2;
  cmBWScreen =                  cmScreenOptionBase + 3;
  cmBWHighScreen =              cmScreenOptionBase + 4;

{$IFDEF mitMedusa}
  cmParseBase =                 cmScreenOptionBase + 10;

  cmScan =                      cmParseBase + 1;
  cmParse =                     cmParseBase + 2;
  cmExecute =                   cmParseBase + 3;
{$ENDIF mitMedusa}

CONST

   (* Fehlende Keyboard-Konstanten: *)

   kbSpace =       $3920;

   kba =           $1E61;
   kbb =           $3062;
   kbc =           $2E63;
   kbd =           $2064;
   kbe =           $1265;
   kbf =           $2166;
   kbg =           $2267;
   kbh =           $2368;
   kbi =           $1769;
   kbj =           $246A;
   kbk =           $256B;
   kbl =           $266C;
   kbm =           $326D;
   kbn =           $316E;
   kbo =           $186F;
   kbp =           $1970;
   kbq =           $1071;
   kbr =           $1372;
   kbs =           $1F73;
   kbt =           $1474;
   kbu =           $1675;
   kbv =           $2F76;
   kbw =           $1177;
   kbx =           $2D78;
   kby =           $2C79;
   kbz =           $157A;

   kb0 =           $0B30;
   kb1 =           $0231;
   kb2 =           $0332;
   kb3 =           $0433;
   kb4 =           $0534;
   kb5 =           $0635;
   kb6 =           $0736;
   kb7 =           $0837;
   kb8 =           $0938;
   kb9 =           $0A39;

   kbCtrlA =       $1E01;
   kbCtrlB =       $3002;
   kbCtrlC =       $2E03;
   kbCtrlD =       $2004;
   kbCtrlE =       $1205;
   kbCtrlF =       $2106;
   kbCtrlG =       $2207;
   kbCtrlH =       $2308;
   kbCtrlI =       $1709;
   kbCtrlJ =       $240A;
   kbCtrlK =       $250B;
   kbCtrlL =       $260C;
   kbCtrlM =       $320D;
   kbCtrlN =       $310E;
   kbCtrlO =       $180F;
   kbCtrlP =       $1910;
   kbCtrlQ =       $1011;
   kbCtrlR =       $1312;
   kbCtrlS =       $1F13;
   kbCtrlT =       $1414;
   kbCtrlU =       $1615;
   kbCtrlV =       $2F16;
   kbCtrlW =       $1117;
   kbCtrlX =       $2D18;
   kbCtrlY =       $2C19;
   kbCtrlZ =       $151A;

   cZeilEndMarke = '';
   cTextEndMarke = #20;
(*********************** Systemkonstante **************************)

        CVersion =              LONGINT (00001005);

        cHeapMin =              LONGINT (30720); {20480;} {10240;}

        cHeapFactor =           LONGINT (10);
        (* eigentlich brauche ich eine Angabe des dynamischen
           Speicherbedarfs eines Objektes, dh. wieviel es verbraucht,
           wenn es erzeugt wird und seine diversen Unterobjekte
           angelegt hat. *)

        (*CVekInd32 =             16777216;*)
        CVekInd32 =             16382;

        CBitMap =               65535;
        CBitMapSize =           CBitMap DIV 8;
        CVekIndByte =           65530; (* QP 65535??? *)
        CRecordGroesse =        CVekIndByte;
        CVekInd16 =             32766;
        CSVekInd16 =            (*16383*) 16382;
        CTVekInd16 =            4092;
        CRealInd16 =            1820;
        CRealFormat =           6; (* Anzahl Bytes, 0 fr CHAR *)

        {CDeltaFactor =          65536;}
        CDeltaFactor =           LONGINT (32768);
        {CDeltaFactor =          10;}

TYPE
        (* Dummy-Typen resp. Umbenennungen... *)

        ASCII =         SYSTEM.TEXT;

        BitMapRange =   0..CBitMapSize;
        VekRangeByte =  0..CVekIndByte;
        VekRange32 =    0..CVekInd32;
        VekRange16 =    0..CVekInd16;
        SVekRange16 =   0..CSVekInd16;
        TVekRange16 =   0..CTVekInd16;
        RealRange16 =   0..CRealInd16;

        {
        CARDINAL =      WORD;
        LONGCARD =      LongInt;
        }
        ADDRESS =       POINTER;
        LONGWORD =      LongInt;
        SHORTBITSET =   SET OF 0..7;
        BITSET =        SET OF 0..15;
        LONGBITSET =    SET OF 0..31;
        BITMAP =        ARRAY [BitMapRange] OF SHORTBITSET;
        PBITMAP =       ^BITMAP;

        TLongPoint =    Record X, Y: LongInt; END;

        einFlag = (geladen, initialisiert, besucht, referiert, gesichert,
                   geloescht, msgempfangen, verdeckt,
                   extendetInit, noXinit, noXDone,
                   editFlag, suchFlag, lokalFlag, setFormular, kollabiert);
{   |  |  |   |
 kflsednxvm  rbig
 1010101010101010- geladen,
 ||||||||:||||||=  initialisiert,
 ||||||||:|||||--  besucht, <--
 ||||||||:||||==== referiert,
 ||||||||:|||----- gesichert,
 ||||||||:||====== geloescht,
 ||||||||:|------- msgempfangen, <--
 ||||||||:======== verdeckt,
 ||||||||--------- extendetInit,
 |||||||========== noXinit, <--
 ||||||----------- noXDone,
 |||||============ editFlag, <-
 ||||------------- suchFlag,
 |||============== lokalFlag,
 ||--------------- setFormular,
 |================ kollabiert
}
(* geladen: Objekt wurde von einLader bereits (teilweise) in den Arbeits-
            speicher gelesen (steuert die kopiere-Funktion)
   initialisiert: Init wurde ausgefhrt
   besucht: Objekt wurde von einer Netzroutine aufgesucht (welche sind das?)
   referiert: auf das Flag besteht eine aktuelle Referenz, es darf nicht
              gelscht werden
   gesichert: aktuelle Objektdaten sind in Datei gesichert
   geloescht: Objekt enthlt keine aktuellen Daten bzw. wurde vom Heap
              entfernt - darf nicht zugegriffen werden
   msgempfangen: Objekt hat einen Aufruf von "sende" erhalten
   verdeckt: (virtuelles) Objekt wurde in Datei ausgelagert, dh. seine
             Daten knnen erst gelesen werden, wenn es wieder in den
             Speicher gebracht wurde
   extendetInit: Die erweiterte Initialisierung "InitX" wurde ausgefhrt.
   noXInit:  InitX nicht ausfhren.
   noXDone:  DISPOSE (Done) nicht an lokale Objekte weitergeben.
   editFlag: Die Daten DIESES Objektes wurden gendert. Siehe auch
             Flag "editiert" in FormFlags, das besagt: Irgendwas an der
             Struktur, die man ber die Pointer des Formulars erreicht,
             wurde gendert (im Cluster).
   suchFlag: Steuert die Suche nach einem Objekt, das ein bestimmtes
             Flag gesetzt hat. Die Prozedur sucheNetzFlag setzt bei
             allen untersuchten Objekten dieses Flag (vgl. besucht)
   lokalFlag: Eine Operation soll nur lokal (im Cluster), nicht im
              Environment, ausgefhrt werden (z. B. kopiere-dupliziere,
              man knnte ev. mal diese Routinen zusammenfassen).
   setFormular: Bewirkt, da setzeFlag bei bestimmten Flags, wie
                z. B. editFlag, eine Message an das Projekt schickt.
                Das bewirkt dann, da das Flag "editiert" im Projekt-
                Formular gesetzt wird!
*)

        einFlagSet = SET OF einFlag; (* zwei Byte, deckungsgleich mit
                                        BITSET *)

(* Master-Aufzhlungstyp fr die syntaktische Deklaration von
   generischen Pointern und fr die Implementierung der Typkennung
   zur Laufzeit.
   VORSICHT!!! Dieser Typ darf wg. der Abspeicherung der Objektkennung
   in Dateien nicht verndert werden (auer durch Anfgen von Bezeich-
   nern am Ende).
*)

TYPE
        einGenTyp =             WORD;
        PeinDruckerFilter =     ^TeinDruckerFilter;
        TeinDruckerFilter =     ARRAY [CHAR] OF STRING [40];

CONST

        (* Allg. Verwaltungstypen: *)

        FehlerTyp0 =     0; (* Dieser Wert kann in gelschten Speicherbereichen
                       (Heapverwaltung!) vorkommen. Fr Zuweisungen
                       verwende besser "FehlerTypX"! *)

        GenBase =        10;

        generisch =      GenBase;

        ObjektManager =  GenBase + 1;
        Signateur =      GenBase + 2;

        Struktur =       GenBase + 10; {Skalar + 30;}  (* abstrakte Oberklasse fr alle Strukturen *)

        (* Stringtypen *)
        StringG =        Struktur + 2;  (* generischer String *)
        String8 =        Struktur + 3;  (* Vektor aus Bytes mit BYTE-Lngenattribut *)
        String16 =       Struktur + 4;  (* Vektor aus Bytes mit CARDINAL-Lngenattribut *)

        MenuString =     Struktur + 6;

        DatumString =    Struktur + 7;

        (* Text *)
        TextBase =       Struktur + 10;
        CharSet =        TextBase + 1; (* 32 Byte = 256 Elemente *)

        TextBas =        TextBase + 2;
        SimpleText =     TextBase + 3;

          (* Objekte zur Textverwaltung, Editor. Enthlt z. B.
             Cursorposition etc., SimpleText ohne Umbruch *)

        Parser =         TextBase + 6;

        (* Typen zum Aufbau von Lexika, sortierten Indizes *)
        IndexBase =      TextBase + 10;

        NetzString =     IndexBase + 1;  (* Zum Aufbau einer WordBase, fr Merker etc. *)
        Lexikon =        IndexBase + 4;

        (* Weitere Indextypen: *)
{
        MultiIndex =     IndexBase + 6;  (* Index, der mehrere Eintrge fr einen Wert zult *)
        HierarchIndex =  IndexBase + 7;  (* Indexstruktur *)
        SynonymIndex =   IndexBase + 8;  (* spezielle Indexstruktur zur Verknpfung von Alias-
                         namen z. B. in der Fachliteratur *)
        SekundaerIndex = IndexBase + 9; (* Index, der sich auf einen an anderer Stelle
                           definierten Index oder SynonymIndex bezieht,
                           dh. Index mit Link *)
}
        SymtabEintrag =  IndexBase + 10;
        Symtabelle =     IndexBase + 11;
{
        TextIndex =      IndexBase + 12;
}
        (* primre Strukturelemente: *)

        TreeBase =       IndexBase + 16;
        Knoten =         TreeBase + 1; (* binr *)
        Triple =         TreeBase + 2; (* drei Pointer *)
        Quadruple =      TreeBase + 3; (* vier Pointer *)

        (************** Listenartige Strukturen *********************)

        Liste =          TreeBase + 5;
        Tabelle =        TreeBase + 11;
        Glue =           TreeBase + 14;
        ListGlue =       TreeBase + 15;
        TextGlue =       TreeBase + 20;
        Merker =         TreeBase + 21;

        (* Vektoren fr Mendefinitionen *)

        MenuBase =       TreeBase + 25; {VektorBase + 10;}
        Menu =           MenuBase + 1;  (* Vektor aus Strings fuer Menuedarstellungen *)
        TVMenu =         MenuBase + 2;  (* MenVektor fr Turbo-Vison *)

        FehlerTypX =    MenuBase + 10; {DatumBase + 10;}
        LetzterTyp =    FehlerTypX + 1;

TYPE
        { einGenSet =     SET OF einGenTyp; -- nicht mehr mglich }
        einGenRange =           generisch..letzterTyp;

        StringPointer =         (* POINTER TO *)^ SSTRING;
        LStringPointer =        (* POINTER TO *)^ LSTRING;
        CHARPOINTER8 =          (* POINTER TO *)^ CHARARRAY8;
        CHARPOINTER16 =         (* POINTER TO *)^ CHARARRAY16;
        CHSET =                 SET OF CHAR;

        CHARARRAY8 =            ARRAY [0..254] OF CHAR;
        CHARARRAY16 =           ARRAY [VekRangeByte] OF CHAR;

        SSTRING =               RECORD
                                  Laenge:       BYTE;
                                  Str:          CHARARRAY8;
                                END;

        LSTRING =               RECORD
                                  Laenge:       WORD;
                                  Str:          CHARARRAY16;
                                END;

(*TYPE BYTE = [0..255];*)

PROCEDURE appendChar (VAR s: STRING; c: CHAR);
PROCEDURE appendString (VAR s1, s2: STRING);

TYPE STRING2 = STRING [2];
     STRING4 = STRING [4];

PROCEDURE HexByte (zahl: BYTE; VAR s: STRING2);
PROCEDURE HexWord (zahl: WORD; VAR s: STRING4);
(* Aus c't 2/92 S. 162, schneller als +, Concat etc.! Siehe dort auch
   schnelle Hexbyte-Routinen *)

FUNCTION StringVonByte (zahl: BYTE): STRING;
FUNCTION StringVonHex (zahl: WORD): STRING;
FUNCTION StringVonNum (num: LONGINT): STRING;
FUNCTION StringVonNumF (num: LONGINT; f: INTEGER): STRING;
FUNCTION StringVonPointer (p: POINTER): STRING;
FUNCTION StringVonError (err: WORD): STRING;
FUNCTION atString (p: POINTER): STRING;
FUNCTION StringVonDatum (KompaktDat: LONGINT; mitZeit: BOOLEAN): STRING;
FUNCTION SystemDatum: LONGINT;
FUNCTION StringVonTyp (typ: einGenTyp): STRING;
FUNCTION StringVonFlag (f: einFlag): STRING;
FUNCTION StringVonFlags (f: einFlagSet): STRING;

(* VORSICHT!!! Die folgenden Operationen arbeiten auf dynamischen Bitmaps,
   ohne eine Bereichsberprfung fr Ind auszufhren!!! *)

PROCEDURE SetBit (PMap: PBITMAP; Ind: WORD);
PROCEDURE ResetBit (PMap: PBITMAP; Ind: WORD);
FUNCTION IsBit (PMap: PBITMAP; Ind: WORD): BOOLEAN;

IMPLEMENTATION

USES DOS;

(***************************** Hilfsprozeduren ****************************)

PROCEDURE appendChar (VAR s: STRING; c: CHAR);
(* Aus c't 2/92 S. 162 *)
VAR   L:  BYTE ABSOLUTE s;
BEGIN
  IF L < 255 THEN BEGIN
    INC (L);
    S [L] := c;
  END (* IF *);
END (* appendChar *);

PROCEDURE appendString (VAR s1, s2: STRING);
VAR  L1:  BYTE ABSOLUTE s1;
     L2:  BYTE ABSOLUTE s2;
     j:   BYTE;
BEGIN
  FOR j := 1 TO L2 DO BEGIN
    IF L1 = 255 THEN EXIT;
    INC (L1);
    s1 [L1] := s2 [j];
  END (* FOR *);
END (* appendString *);

PROCEDURE HexByte (zahl: BYTE; VAR s: STRING2);
CONST  Ziffern:  ARRAY [0..15] OF CHAR = '0123456789ABCDEF';
BEGIN
  s[0] := #2;
  s[1] := Ziffern [zahl SHR 4];
  s[2] := Ziffern [zahl AND $0F];
END (* HexByte *);

PROCEDURE HexWord (zahl: WORD; VAR s: STRING4);
VAR  tricky:  RECORD
                CASE BOOLEAN OF
                  TRUE: (LowB, HiB: BYTE);
                  FALSE: (Wo: WORD);
              END;
     HiS, LoS: STRING2;
BEGIN
  tricky.Wo := zahl;
  HexByte (tricky.HiB, HiS);
  HexByte (tricky.LowB, LoS);
  s := His; appendString (s, Los);
END (* HexWord *);

FUNCTION StringVonNum (num: LONGINT): STRING;
VAR stri:  STRING [10];
BEGIN
  Str (num, stri);
  StringVonNum := stri;
END (* StringVonNum *);

FUNCTION StringVonNumF (num: LONGINT; f: INTEGER): STRING;
VAR stri:  STRING [80];
    i:     INTEGER;
BEGIN
  stri := StringVonNum (num);
  FOR i := LENGTH (stri) TO f-1 DO
    Insert (' ', stri, 1);
  StringVonNumF := stri;
END (* StringVonNumF *);

FUNCTION StringVonError (err: WORD): STRING;
BEGIN
  CASE err OF
    0:    StringVonError := 'Normal termination';
    2:    StringVonError := 'File not found';
    3:    StringVonError := 'Path not found';
    4:    StringVonError := 'Too many open files';
    5:    StringVonError := 'File access denied';
    6:    StringVonError := 'Invalid file handle';
    12:   StringVonError := 'Invalid file access mode';
    15:   StringVonError := 'Invalid drive number';
    16:   StringVonError := 'Cannot remove current directory';
    17:   StringVonError := 'Cannot rename across drives';
    100:  StringVonError := 'Disk read error';
    101:  StringVonError := 'Disk write error';
    102:  StringVonError := 'File not assigned';
    103:  StringVonError := 'File not open';
    104:  StringVonError := 'File not open for input';
    105:  StringVonError := 'File not open for output';
    106:  StringVonError := 'Invalid numeric format';
    150:  StringVonError := 'Disk is write protected';
    151:  StringVonError := 'Unknown Unit (peripheral)';
    152:  StringVonError := 'Drive not ready';
    153:  StringVonError := 'Unknown DOS-command';
    154:  StringVonError := 'CRC error in data';
    155:  StringVonError := 'Bad drive request structure length';
    156:  StringVonError := 'Disk seek error';
    157:  StringVonError := 'Unknown media type';
    158:  StringVonError := 'Sector not found';
    159:  StringVonError := 'Printer out of paper';
    160:  StringVonError := 'Device write fault';
    161:  StringVonError := 'Device read fault';
    162:  StringVonError := 'Hardware failure';
    200:  StringVonError := 'Division by zero';
    201:  StringVonError := 'Range check error';
    202:  StringVonError := 'Stack overflow error';
    203:  StringVonError := 'Heap overflow error';
    204:  StringVonError := 'Invalid pointer operation (Dispose, Freemem)';
    205:  StringVonError := 'Floating point overflow';
    206:  StringVonError := 'Floating point underflow';
    207:  StringVonError := 'Invalid floating point operation';
    208:  StringVonError := 'Overlay manager not installed';
    209:  StringVonError := 'Overlay file read error';
    210:  StringVonError := 'Object not initialized';
    211:  StringVonError := 'Call to abstract method';
    212:  StringVonError := 'Stream registration error';
    213:  StringVonError := 'Collection index out of range';
    214:  StringVonError := 'Collection overflow error';
    215:  StringVonError := 'Arithmetic overflow error';
    216:  StringVonError := 'General Protection fault';
    1000: StringVonError := 'Error Test';
  ELSE StringVonError := StringVonNum (err);
  END (* CASE *);

  (* Bemerkung: Kann durch HALT (x) oder RunError (x) erweitert werden! *)
END (* StringVonError *);

FUNCTION atString (p: POINTER): STRING;
BEGIN
  atString := ' @' + StringVonPointer (p);
END (* atString *);

FUNCTION StringVonByte (zahl: BYTE): STRING;
VAR HexStr: STRING [2];
BEGIN
  HexByte (zahl, HexStr);
  StringVonByte := HexStr;
END (* StringVonHex *);

FUNCTION StringVonHex (zahl: WORD): STRING;
VAR HexStr: STRING [4];
BEGIN
  HexWord (zahl, HexStr);
  StringVonHex := HexStr;
END (* StringVonHex *);

FUNCTION StringVonPointer (p: POINTER): STRING;
VAR  tricky: RECORD
               CASE BOOLEAN OF
                 TRUE: (LowP, HiP: WORD);
                 FALSE: (poin: POINTER);
               END;
     LowS:  STRING [4];
     PS:    STRING [9];
BEGIN
  tricky.poin := p;
  HexWord (tricky.HiP, PS);
  appendChar (PS, ':');
  HexWord (tricky.LowP, LowS);
  appendString (PS, LowS);

  StringVonPointer := PS;
END (* StringVonPointer *);

FUNCTION StringVonDatum (KompaktDat: LONGINT; mitZeit: BOOLEAN): STRING;
VAR  SysDatum:  DateTime;
     DatStr:    STRING [60];
BEGIN
  UnpackTime (KompaktDat, SysDatum);
  WITH SysDatum DO BEGIN
    DatStr := Concat (StringVonNum (Day), '.', StringVonNum (Month), '.',
                      StringVonNum (Year));
    IF mitZeit THEN
      DatStr := Concat (DatStr, ' ',
                      StringVonNum (Hour), ':', StringVonNum (Min), ':',
                      StringVonNum (Sec));
  END (* WITH *);
  StringVonDatum := DatStr;
END (* StringVonDatum *);

FUNCTION SystemDatum: LONGINT;
VAR  SysDatum:  DateTime;
     Sec100:    WORD;
     DayofWeek: WORD;
     Kompakt:   LONGINT;
BEGIN
  WITH SysDatum DO BEGIN
    GetTime (Hour, Min, Sec, Sec100);
    GetDate (Year, Month, Day, DayofWeek);
  END (* WITH *);
  PackTime (SysDatum, Kompakt);
  SystemDatum := Kompakt;
END (* SystemDatum *);

FUNCTION StringVonTyp (typ: einGenTyp): STRING;
BEGIN
  CASE typ OF
    FehlerTyp0:         StringVonTyp := 'FehlerTyp0';

    generisch:          StringVonTyp := 'generisch';
    ObjektManager:      StringVonTyp := 'ObjektManager';
    Signateur:          StringVonTyp := 'Signateur';
    Struktur:           StringVonTyp := 'Struktur';
    StringG:            StringVonTyp := 'StringG';
    String8:            StringVonTyp := 'String8';
    String16:           StringVonTyp := 'String16';

    MenuString:         StringVonTyp := 'MenuString';

    DatumString:        StringVonTyp := 'DatumString';

    CharSet:            StringVonTyp := 'CharSet';

    SimpleText:         StringVonTyp := 'SimpleText';
    Parser:             StringVonTyp := 'Parser';

    Knoten:             StringVonTyp := 'Knoten';
    Triple:             StringVonTyp := 'Triple';
    Quadruple:          StringVonTyp := 'Quadruple';
    Liste:              StringVonTyp := 'Liste';
    Tabelle:            StringVonTyp := 'Tabelle';
    Glue:               StringVonTyp := 'Glue';
    ListGlue:           StringVonTyp := 'ListGlue';
    TextGlue:           StringVonTyp := 'TextGlue';
    Merker:             StringVonTyp := 'Merker';
    Menu:               StringVonTyp := 'Menu';
    TVMenu:             StringVonTyp := 'TVMenu';
    FehlerTypX:         StringVonTyp := 'FehlerTypX';

    ELSE                StringVonTyp := 'Fehler in meinTyp';
  END (* CASE *);
END (* StringVonTyp *);

FUNCTION StringVonFlag (f: einFlag): STRING;
BEGIN
      CASE f OF
        geladen:        StringVonFlag := 'geladen';
        initialisiert:  StringVonFlag := 'initialisiert';
        besucht:        StringVonFlag := 'besucht';
        referiert:      StringVonFlag := 'referiert';
        gesichert:      StringVonFlag := 'gesichert';
        geloescht:      StringVonFlag := 'geloescht';
        msgempfangen:   StringVonFlag := 'msgempfangen';
        verdeckt:       StringVonFlag := 'verdeckt';
        extendetInit:   StringVonFlag := 'extendetInit';
        noXinit:        StringVonFlag := 'noXInit';
        noXDone:        StringVonFlag := 'noXDone';
        editFlag:       StringVonFlag := 'editFlag';
        suchFlag:       StringVonFlag := 'suchFlag';
        lokalFlag:      StringVonFlag := 'lokalFlag';
        setFormular:    StringVonFlag := 'setFormular';
        kollabiert:     StringVonFlag := 'kollabiert';
      END (* CASE *);
END (* StringVonFlag *);

FUNCTION StringVonFlags (f: einFlagSet): STRING;
VAR     i:      einFlag;
        s:      STRING [80];
BEGIN
  s := '{';
  FOR i := geladen TO kollabiert DO BEGIN
    IF i IN f THEN BEGIN
      Insert (StringVonFlag (i) + ' ', s, Length (s) + 1);
    END (* IF *);
  END (* FOR *);
  s := s + '}';
  StringVonFlags := s;
END (* StringVonFlags *);

PROCEDURE SetBit (PMap: PBITMAP; Ind: WORD);
VAR MapInd, BitInd: BYTE;
BEGIN
  MapInd := Ind DIV 8; BitInd := Ind MOD 8;
  PMap^[MapInd] := PMap^[MapInd] + [BitInd];
END;

PROCEDURE ResetBit (PMap: PBITMAP; Ind: WORD);
VAR MapInd, BitInd: BYTE;
BEGIN
  MapInd := Ind DIV 8; BitInd := Ind MOD 8;
  PMap^[MapInd] := PMap^[MapInd] - [BitInd];
END;

FUNCTION IsBit (PMap: PBITMAP; Ind: WORD): BOOLEAN;
BEGIN
  IsBit := IND MOD 8 IN PMap^[Ind DIV 8];
END;

END (* GLFTypes *).
