{$A+,B-,D+,E+,F+,G+,I+,L+,N-,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 65520, 0, 655360}
UNIT TVMenus;

{$F+}
{$O+}

(* (C) 1990, 1991, 1992, 1993, 1994, 1995 by Johannes Leckebusch
   Version 2.926
   Anpassung an TP: 9. 12. 90
   23. 03. 93: Nichtrekursives Lschen von Text und Textobjekt
   Stand: 19. 12. 1995
*)


INTERFACE

USES Objects, Drivers, {My}Views, GLFTypes, GLFBase, ObjStrings, GLFNodes,
     GLFLists, GLFViews, TextBase, Simpeltext;

TYPE

  einTVMenuPointer = ^einTVMenu;
  einTVMenu = OBJECT (einSimpleText)
                CONSTRUCTOR Init (CONST xflags: einFlagSet);
                DESTRUCTOR Done; VIRTUAL;
                FUNCTION erzeugeMich (CONST xflags: einFlagSet): GLP; VIRTUAL;
                FUNCTION isSubclass (CONST class: einGenTyp): BOOLEAN; VIRTUAL;
                PROCEDURE setzeTextUndCode (CONST s, suf: STRING; CONST c, b, k: WORD);
                  VIRTUAL;
                PROCEDURE insertTextUndCode (CONST s, suf: STRING; CONST c, b, k: WORD);
                  VIRTUAL;
                PROCEDURE holeTextUndCode (VAR s, suf: STRING; VAR c, b, k: WORD);
                  VIRTUAL;
              END (* einTVMenu *);

IMPLEMENTATION

USES DOS, {My}App, {My}Dialogs, StdDlg, Fields, EditStuff,
  GLFStructures, TVMenuString, GLFWindows;

(************************** Methoden TVMenus ****************************)

CONSTRUCTOR einTVMenu.Init;
BEGIN
  INHERITED Init (xflags + [noXInit]);
  meinTyp := TVMenu;
  StandardZeile := MenuString;
  {meineTextFlags := [];}
END (* Init *);

DESTRUCTOR einTVMenu.Done;
BEGIN
  INHERITED Done;
END;

FUNCTION einTVMenu.erzeugeMich (CONST xflags: einFlagSet): GLP;
BEGIN
  erzeugeMich := NEW (einTVMenuPointer, Init (xflags));
END (* erzeugeMich *);

FUNCTION einTVMenu.isSubclass (CONST class: einGenTyp): BOOLEAN;
BEGIN
  isSubclass := (class = TVMenu) OR INHERITED isSubClass (class);
END (* Member *);

PROCEDURE einTVMenu.setzeTextUndCode (CONST s, suf: STRING; CONST c, b, k: WORD);
BEGIN
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubclass (MenuString)) THEN BEGIN
    einMenuStringPointer (laufendeZeile^.getZ)^.setzeStringUndCode (s, suf, c, b, k, TRUE);
  END (* IF *);
END (* setzeTextUndCode *);

PROCEDURE einTVMenu.insertTextUndCode (CONST s, suf: STRING; CONST c, b, k: WORD);
BEGIN
  insertZeile;
  setzeTextUndCode (s, suf, c, b, k);
END (* insertTextUndCode *);

PROCEDURE einTVMenu.holeTextUndCode (VAR s, suf: STRING; VAR c, b, k: WORD);
BEGIN
  IF (laufendeZeile <> NIL) AND (laufendeZeile^.getZ^.isSubclass (MenuString)) THEN BEGIN
    einMenuStringPointer (laufendeZeile^.getZ)^.holeStringUndCode (s, suf, c, b, k);
  END
  ELSE BEGIN
    Write ('holeTextUndCode - Subclass failure'); ReadLn;
  END;
END (* holeTextUndCode *);

END (* TVMenus *).